using System;
using System.IO;
using ArtOfTest.WebAii.BrowserSpecialized.AspNetHost;
using ArtOfTest.WebAii.Controls.HtmlControls;
using ArtOfTest.WebAii.Core;
using ArtOfTest.WebAii.ObjectModel;
using ArtOfTest.WebAii.TestTemplates;
using NUnit.Framework;

namespace UnitTests.CMSPortal.Web
{
	[TestFixture]
	public class Login : BaseTest //: TestFixturePageBase
	{
		private const string PAGE_NAME = "~/Login.aspx";
		private HtmlInputText _usernameTextbox;
		private HtmlInputPassword _userpasswordTextbox;
		private Element _loginButton;
		
		#region Setup/Teardown

		[SetUp]
		public void SetUp()
		{
			Settings settings = GetSettings();
			settings.Web.DefaultBrowser = BrowserType.AspNetHost;
			settings.Web.WebAppPhysicalPath = Path.GetFullPath(Path.Combine(NUnit.Core.TestExecutionContext.CurrentContext.CurrentDirectory, @"..\..\..\CMSPortal.Web"));
			Initialize(settings, new TestContextWriteLine(NUnit.Core.TestExecutionContext.CurrentContext.Out.WriteLine));
		}

		[TearDown]
		public void Destroy()
		{
			// Shuts down WebAii manager and closes all browsers currently running
			CleanUp();
		}
		#endregion
		
		[Test]
		public void Layout_Telerik()
		{
			Manager.LaunchNewBrowser();
			ActiveBrowser.NavigateTo(PAGE_NAME);
			if (ActiveBrowser.BrowserType != BrowserType.AspNetHost)
			{
				Assert.Fail("Blah!");
			}
			AspNetHostBrowser hostBrowser = (AspNetHostBrowser)ActiveBrowser;
			Assert.IsTrue(hostBrowser.Status == 200);
			Find.ById<HtmlTable>("Content_Login1").ScrollToVisible();
			_usernameTextbox = Find.ById<HtmlInputText>("Content_Login1_UserName");
			_userpasswordTextbox = Find.ById<HtmlInputPassword>("Content_Login1_Password");
			_loginButton = Find.ById("Content_Login1_LoginButton");
			Assert.IsNotNull(_usernameTextbox);
			Assert.IsNotNull(_userpasswordTextbox);
			Assert.IsNotNull(_loginButton);
			_usernameTextbox.Text = "wtester";
			_userpasswordTextbox.Text = "Password!123";
			Actions.Click(_loginButton);
			hostBrowser.Refresh();
			Console.Out.WriteLine("SourceHtml = {0}", hostBrowser.ViewSourceString);
		}
	}
}